// BasicSumRuleMaster.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * This is the basic class of rule master, which is inherited from others.
 * A rule master contains the rule for the agent's acts.
 * 
 *
 * @author Marco Agagliate 
 *  
 */
public class BasicSumRuleMaster extends SwarmObjectImpl
        {
        /**
         * The probability of placing an order in the opening or closing phase.
         * So a day starts and finish with an auction, with a realistic effect. 
         */
        public double agentProbToActInOpeningOrClosingAuctions;
        /**
         * The coefficient that RandomAgents multiplays
         * by the last price for the order.
         */
        public double minCorrectingCoeff;
        /**
         * The coefficient that RandomAgents multiplays
         * by the last price for the order.
         */
        public double maxCorrectingCoeff;
        /** The asimmetry of max/minCorrectingCoeff. */
        public double asymmetricRange;
        /** This is the floor price. */
        public double floorP;
        /**
         * The probability that an agent would buy
         * if the price is below floorP.
         */
        public double agentProbToActBelowFloorP;

        /** Constructor for a new BasicSumRuleMaster. */
        public BasicSumRuleMaster(Zone aZone)
                {
                super(aZone);
                }

        /** This method sets the agentProbToActInOpeningOrClosingAuctions. */
        public void setAgentProbToActInOpeningOrClosingAuctions(double p)
                {
                agentProbToActInOpeningOrClosingAuctions=p;
                }

        /** This method sets the minCorrectingCoeff. */
        public void setMinCorrectingCoeff(double min)
                {
                minCorrectingCoeff=min;
                }

        /** This method sets the setMaxCorrectingCoeff. */
        public void setMaxCorrectingCoeff(double max)
                {
                maxCorrectingCoeff=max;
                }

        /** This method sets the asymmetricRange. */
        public void setAsymmetricRange(double a)
                {
                asymmetricRange=a;
                }

        /** This method sets the floorP and AgentProbToActBelowFloorP. */
        public void setFloorP$andAgentProbToActBelowFloorP(double f, double p)
                {
                floorP=f;
                agentProbToActBelowFloorP=p;
                }
        }

