// RandomAgent.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * This is the RandomAgent. RandomAgent acts at random.
 * 
 * 
 *
 * @author Marco Agagliate integrations of Antonio de Ruvo
 *  
 */
public class RandomAgent extends BasicSumAgent
        {
	/** This variable is for send order to the book. */
	public double[] order = new double[4];

        /** This is the agent's rule master. */
        public RandomRuleMaster ruleMaster;

        /** Constructor for a new RandomAgent. */
        public RandomAgent(Zone aZone,int maxOrderQuantity)
                {
                super(aZone, maxOrderQuantity);
                }

        /** This method sets the rule master. */
        public void setRuleMaster(RandomRuleMaster r)
                {
                ruleMaster=r;
                }

        /** This method is called in the first phase of the day. */
        public void act0()
                {
                double lastPrice;
                int i;

                buySellSwitch=0.5;
                lastPrice=theBook.getPrice(); 
                price = ruleMaster.getPriceInOpeningOrClosingAuctions (lastPrice, buySellSwitch);
                if (maxOrderQuantity==1) 
                        iMax=1;
                else
                        iMax=Globals.env.uniformIntRand.getIntegerWithMin$withMax
                                                                (1, maxOrderQuantity);
                if (price!=0 && agentProbToActWithMarketPrice > Globals.env.uniformDblRand
		    .getDoubleWithMin$withMax(0.0, 1.0)){
		   //sell
		   if(price<0){
		       order[0]=0;
		       order[3]=2;
		   }
		   //buy
		   else if(price>0){
		       order[0]=0;
		       order[3]=1;
		   }
		}
		else {
		  order[0]=price;
		  order[3]=0;
		}
		order[1]=number;
		order[2]=iMax;
		if(printing==2){
                  System.out.println("I'm the random agent "+order[1]+" in act0 and I sent an order for "
                                     +order[2]+" shares at price "+order[0]);
		}
                theBook.setOrderInOpeningOrClosingAuctionsFromAgent (order);
                }

        /** This method is called in the first phase of the day.
         *  The agent acts in the market.
         */
        public void act1()
                {
                double lastPrice;
                int i;

                buySellSwitch=0.5;
                lastPrice=theBook.getPrice();
                price = ruleMaster.getPrice (lastPrice, buySellSwitch);
                if (maxOrderQuantity==1) 
                        iMax=1;
                else
                        iMax=Globals.env.uniformIntRand.getIntegerWithMin$withMax
                                                                (1, maxOrderQuantity);
                if (price!=0 && agentProbToActWithMarketPrice > Globals.env.uniformDblRand
		    .getDoubleWithMin$withMax(0.0, 1.0)){
		   //sell
		   if(price<0){
		       order[0]=0;
		       order[3]=2;
		   }
		   //buy
		   else if(price>0){
		       order[0]=0;
		       order[3]=1;
		   }
		}
		else {
		  order[0]=price;
		  order[3]=0;
		}
		order[1]=number;
		order[2]=iMax;
		if(printing==2){
                  System.out.println("I'm the random agent "+order[1]+" in act1 and I sent an order for "
                                     +order[2]+" shares at price "+order[0]);
		}
                theBook.setOrderFromAgent (order);
                }
        }



